# mailslurp-client
For documentation see [developer guide](https://www.mailslurp.com/developers). [Create an account](https://app.mailslurp.com) in the MailSlurp Dashboard to [view your API Key](https://app). For all bugs, feature requests, or help please [see support](https://www.mailslurp.com/support/).

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 0.0.1-alpha
- Package version: 4.2.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen
For more information, please visit [https://www.mailslurp.com](https://www.mailslurp.com)

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on Github, you can install directly from Github

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import mailslurp_client 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import mailslurp_client
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import mailslurp_client
from mailslurp_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: API_KEY
configuration = mailslurp_client.Configuration()
configuration.api_key['x-api-key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-api-key'] = 'Bearer'

# create an instance of the API class
api_instance = mailslurp_client.CommonOperationsApi(mailslurp_client.ApiClient(configuration))

try:
    # Create new email address
    api_response = api_instance.create_new_email_address()
    pprint(api_response)
except ApiException as e:
    print("Exception when calling CommonOperationsApi->create_new_email_address: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *https://api.mailslurp.com*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*CommonOperationsApi* | [**create_new_email_address**](docs/CommonOperationsApi.md#create_new_email_address) | **POST** /newEmailAddress | Create new email address
*CommonOperationsApi* | [**send_email_simple**](docs/CommonOperationsApi.md#send_email_simple) | **POST** /sendEmail | Send an email from a random email address
*CommonOperationsApi* | [**wait_for_latest_email**](docs/CommonOperationsApi.md#wait_for_latest_email) | **GET** /fetchLatestEmail | Fetch inbox&#39;s latest email or if empty wait for email to arrive
*ExtraOperationsApi* | [**bulk_create_inboxes**](docs/ExtraOperationsApi.md#bulk_create_inboxes) | **POST** /bulk/inboxes | Bulk create Inboxes (email addresses)
*ExtraOperationsApi* | [**bulk_delete_inboxes**](docs/ExtraOperationsApi.md#bulk_delete_inboxes) | **DELETE** /bulk/inboxes | Bulk Delete Inboxes
*ExtraOperationsApi* | [**bulk_send_emails**](docs/ExtraOperationsApi.md#bulk_send_emails) | **POST** /bulk/send | Bulk Send Emails
*ExtraOperationsApi* | [**create_inbox**](docs/ExtraOperationsApi.md#create_inbox) | **POST** /inboxes | Create an Inbox (email address)
*ExtraOperationsApi* | [**create_webhook**](docs/ExtraOperationsApi.md#create_webhook) | **POST** /inboxes/{inboxId}/webhooks | Attach a WebHook URL to an inbox
*ExtraOperationsApi* | [**delete_email**](docs/ExtraOperationsApi.md#delete_email) | **DELETE** /emails/{emailId} | Delete Email
*ExtraOperationsApi* | [**delete_inbox**](docs/ExtraOperationsApi.md#delete_inbox) | **DELETE** /inboxes/{inboxId} | Delete Inbox / Email Address
*ExtraOperationsApi* | [**delete_webhook**](docs/ExtraOperationsApi.md#delete_webhook) | **DELETE** /inboxes/{inboxId}/webhooks/{webhookId} | Delete and disable a WebHook for an Inbox
*ExtraOperationsApi* | [**download_attachment**](docs/ExtraOperationsApi.md#download_attachment) | **GET** /emails/{emailId}/attachments/{attachmentId} | Get email attachment
*ExtraOperationsApi* | [**get_email**](docs/ExtraOperationsApi.md#get_email) | **GET** /emails/{emailId} | Get Email Content
*ExtraOperationsApi* | [**get_emails**](docs/ExtraOperationsApi.md#get_emails) | **GET** /inboxes/{inboxId}/emails | List Emails in an Inbox / EmailAddress
*ExtraOperationsApi* | [**get_inbox**](docs/ExtraOperationsApi.md#get_inbox) | **GET** /inboxes/{inboxId} | Get Inbox / EmailAddress
*ExtraOperationsApi* | [**get_inboxes**](docs/ExtraOperationsApi.md#get_inboxes) | **GET** /inboxes | List Inboxes / Email Addresses
*ExtraOperationsApi* | [**get_raw_email_contents**](docs/ExtraOperationsApi.md#get_raw_email_contents) | **GET** /emails/{emailId}/raw | Get Raw Email Content
*ExtraOperationsApi* | [**get_webhooks**](docs/ExtraOperationsApi.md#get_webhooks) | **GET** /inboxes/{inboxId}/webhooks | Get all WebHooks for an Inbox
*ExtraOperationsApi* | [**send_email**](docs/ExtraOperationsApi.md#send_email) | **POST** /inboxes/{inboxId} | Send Email


## Documentation For Models

 - [BasicAuthOptions](docs/BasicAuthOptions.md)
 - [BulkSendEmailOptions](docs/BulkSendEmailOptions.md)
 - [CreateWebhookOptions](docs/CreateWebhookOptions.md)
 - [Email](docs/Email.md)
 - [EmailAnalysis](docs/EmailAnalysis.md)
 - [EmailPreview](docs/EmailPreview.md)
 - [Inbox](docs/Inbox.md)
 - [SendEmailOptions](docs/SendEmailOptions.md)
 - [Webhook](docs/Webhook.md)


## Documentation For Authorization


## API_KEY

- **Type**: API key
- **API key parameter name**: x-api-key
- **Location**: HTTP header


## Author

contact@mailslurp.dev


